DECLARE SUB CalcUV (Poly() AS ANY, VertexNormal() AS ANY)
DECLARE SUB DrawTorusP (Model() AS ANY, Poly() AS ANY)
DECLARE SUB SetPlasmaPal ()
DECLARE SUB SortIndex (Poly() AS ANY, Min%, Max%)
DECLARE SUB SortPolys (Model() AS ANY, Poly() AS ANY)
DECLARE SUB LoadTorus2 (Rings%, Bands%, RINGRADIUS%, BandRadius%, Model() AS ANY, Poly() AS ANY)
DECLARE SUB AF.Print (Xpos%, Ypos%, Text$, col%)
DECLARE SUB GreyScalePal ()
DECLARE SUB DrawTorusL (Model() AS ANY, Poly() AS ANY)
DECLARE SUB DrawTorus (Model() AS ANY, Poly() AS ANY)
DECLARE SUB DrawTorusT (Model() AS ANY, Poly() AS ANY)
DECLARE SUB DrawTorusG (Model() AS ANY, Poly() AS ANY)
DECLARE SUB Tritexture (textseg%, xx1%, yy1%, uu1%, vv1%, xx2%, yy2%, uu2%, vv2%, xx3%, yy3%, uu3%, vv3%)
DECLARE SUB HTLine (xx1%, xx2%, yy%, uu1&, uu2&, vv1&, vv2&)
DECLARE SUB CalcNormals (Model() AS ANY, ModelConnect() AS ANY, v() AS ANY, v2() AS ANY)
DECLARE SUB TriGouraud (xx1%, yy1%, Cc1%, xx2%, yy2%, Cc2%, xx3%, yy3%, Cc3%)
DECLARE SUB HLine (x1%, x2%, y%, Col1&, Col2&)
DECLARE SUB FlatTri (xx1%, yy1%, xx2%, yy2%, xx3%, yy3%, col%)
DECLARE SUB SetVideoSeg (Segment%)
DECLARE SUB RotateAndProject (Model() AS ANY, AngleX%, AngleY%, AngleZ%)
DECLARE SUB RotNormals (v() AS ANY, v2() AS ANY, AngleX%, AngleY%, AngleZ%)
'Rotating 3d torus
'Relsoft
'Poly Filling by Generic
'SetVideoSeg by Plasma357
'Torus Tesellation by Biskbart.

DEFINT A-Z
REM $DYNAMIC



TYPE Point3d
        x       AS SINGLE                   'Normal 3d coords
        y       AS SINGLE
        z       AS SINGLE
        Xr      AS SINGLE                   'Rotated  3d coords
        Yr      AS SINGLE
        Zr      AS SINGLE
        ScrX    AS INTEGER                  'Translated and projected
        ScrY    AS INTEGER                  '2d Coords
END TYPE

TYPE PolyType
        p1      AS INTEGER          'faces
        p2      AS INTEGER
        p3      AS INTEGER
        u1      AS INTEGER          'Texture U and V
        v1      AS INTEGER
        u2      AS INTEGER
        v2      AS INTEGER
        u3      AS INTEGER
        v3      AS INTEGER
        Texture AS INTEGER          'Type of Texture
        zcenter  AS INTEGER          'Sorting vars
        idx     AS INTEGER          'Index
        clr     AS INTEGER          'Flat Filling
END TYPE

TYPE vectorType
        x      AS SINGLE
        y      AS SINGLE
        z      AS SINGLE
END TYPE


CONST LENS = 256                            'Z
CONST XCENTER = 160                         '??
CONST YCENTER = 100                         '??

CONST TORNUMRINGS = 20          'Number of Rings outside TORUS
CONST TORNUMBANDS = 10          'Number of PIXEL per RING
CONST TORRINGRADIUS = 65       'Radius of the Ring
CONST TORBANDRADIUS = 20        'Radius of the BAND

CONST PI = 3.14151693#

REDIM SHARED Vpage(32009)  AS INTEGER
DIM SHARED LCOS(359) AS SINGLE
DIM SHARED LSIN(359) AS SINGLE

'Polyhedra stuff
REDIM SHARED TorusModel(1) AS Point3d               '3d  Coords
REDIM SHARED TorusPoly(1) AS PolyType               'Faces
REDIM SHARED TorusNormal(1) AS vectorType           'Orig facenormal(Lamberts)
REDIM SHARED TorusNormal2(1) AS vectorType          'rotated facenormal
REDIM SHARED TorusVertexNormal(1) AS vectorType     'Orig point Normals
REDIM SHARED TorusVertexNormal2(1) AS vectorType    'Rotated(Gouraud)


DIM SHARED Texture%(32 * 32)                       'Nice textures
DIM SHARED Texture2%(32 * 32)                      'Nice textures

DIM SHARED ThetaX, ThetaY, ThetaZ
DIM SHARED zcenter, CamX, CamY
DIM SHARED LightNormal AS vectorType

DIM SHARED Lsin1%(-1024 TO 1024)
DIM SHARED Lsin2%(-1024 TO 1024)
DIM SHARED Lsin3%(-1024 TO 1024)

 FOR i% = -1024 TO 1024
    Lsin1%(i%) = SIN(i% / (128)) * 128      'Play with these values
    Lsin2%(i%) = SIN(i% / (8)) * 128       'for different types of fx
    Lsin3%(i%) = SIN(i% / (16)) * 128        ';*)

 NEXT i%

'PreCalc sin and cos lookuptable

FOR i = 0 TO 359
    a! = i * PI / 180
    LCOS(i) = COS(a!)
    LSIN(i) = SIN(a!)
NEXT i

LightNormal.x = 1               'Light is from the camera
LightNormal.y = -1              'Gouraud shading
LightNormal.z = -1              'Left hand-side from camera


ThetaX = 0
ThetaY = 0
ThetaZ = 0

'Initialize 3d stuff
'we are NOT going to realtime calculate normals but
'instead, we are going to rotate 'em.
'trust me, it's more elegant and faster(no messy SQRs in realtime)

LoadTorus2 TORNUMRINGS, TORNUMBANDS, TORRINGRADIUS, TORBANDRADIUS, TorusModel(), TorusPoly()
RotateAndProject TorusModel(), ThetaX, ThetaY, ThetaZ
CalcNormals TorusModel(), TorusPoly(), TorusNormal(), TorusVertexNormal()
CalcUV TorusPoly(), TorusVertexNormal()
CLS
SCREEN 13
RANDOMIZE TIMER


'Set up our texture
FOR y = 0 TO 31
FOR x = 0 TO 31
    PSET (x, y), 100 + y OR x
NEXT x
NEXT y


DEF SEG = VARSEG(Texture%(0))
offs& = 0
FOR y = 0 TO 31
FOR x = 0 TO 31
    C = POINT(x, y)
    POKE offs&, C
    offs& = offs& + 1
NEXT x
NEXT y

'Set up our texture
FOR y = 0 TO 31
FOR x = 0 TO 31
    PSET (x, y), ABS((x ^ 2 + y ^ 2) MOD 64) + 16
NEXT x
NEXT y

DEF SEG = VARSEG(Texture2%(0))
offs& = 0
FOR y = 0 TO 31
FOR x = 0 TO 31
    C = POINT(x, y)
    POKE offs&, C
    offs& = offs& + 1
NEXT x
NEXT y

DEF SEG


ThetaX = 0
ThetaY = 0
ThetaZ = 0
zcenter = LENS


Vpage(6) = 2560
Vpage(7) = 200
Layer = VARSEG(Vpage(0)) + 1
SetVideoSeg Layer
FillType = 1
Finished = 0
dir% = 1

DO



     ThetaX = (ThetaX + 1) MOD 360
     ThetaY = (ThetaY + 1) MOD 360
     ThetaZ = (ThetaZ + 1) MOD 360

     RotateAndProject TorusModel(), ThetaX, ThetaY, ThetaZ
     RotNormals TorusNormal(), TorusNormal2(), ThetaX, ThetaY, ThetaZ
     RotNormals TorusVertexNormal(), TorusVertexNormal2(), ThetaX, ThetaY, ThetaZ
     SortPolys TorusModel(), TorusPoly()


     k$ = INKEY$
     IF k$ <> "" THEN
        FillType = FillType + 1
        SELECT CASE FillType
            CASE 1
            CASE 2
                GreyScalePal
                PalInit = 1
            CASE 3
            CASE 4
            CASE 5
                SetPlasmaPal
            CASE ELSE
                Finished = 1
        END SELECT
     END IF
     SetVideoSeg Layer
     LINE (0, 0)-(319, 199), 0, BF
     SELECT CASE FillType
        CASE 1              'colors galore!!!
            DrawTorus TorusModel(), TorusPoly()
        CASE 2              'lambert
            DrawTorusL TorusModel(), TorusPoly()
        CASE 3              'gouraud
            DrawTorusG TorusModel(), TorusPoly()
        CASE 4              'textured
            DrawTorusT TorusModel(), TorusPoly()
        CASE 5              'Plasma
            Counter& = (Counter& + dir%)
            IF Counter& > 600 THEN dir% = -dir%
            IF Counter& < -600 THEN dir% = -dir%
            Rot% = 64 * (((Counter& AND 1) = 1) OR 1)
            DEF SEG = VARSEG(Texture%(0))
            offs& = 0
            FOR tty% = 0 TO 31
            FOR ttx% = 0 TO 31
                C% = Lsin3%(ttx% - Counter&) + Lsin1%(tty% - Counter&) + Lsin2%(tty% + ttx%)
                POKE offs&, C%
                offs& = offs& + 1
            NEXT ttx%
            NEXT tty%
            DrawTorusP TorusModel(), TorusPoly()
            'just for the show
            FOR tty% = 0 TO 31
            FOR ttx% = 0 TO 31
                C% = Lsin3%(ttx% - Counter&) + Lsin1%(tty% - Counter&) + Lsin2%(tty% + ttx%)
                PSET (ttx%, tty% + 50), C%
            NEXT ttx%
            NEXT tty%
        CASE ELSE
     END SELECT
     AF.Print 0, 0, "Press a key to Rotate filltypes", 167
     AF.Print 0, 10, "relsoft 2003", 235

     SetVideoSeg &HA000
     PUT (0, 0), Vpage(6), PSET

LOOP UNTIL Finished

END

REM $STATIC
SUB AF.Print (Xpos%, Ypos%, Text$, col%)
'Prints the standard 8*8 CGA font
'Paramenters:
'Segment=the Layer to print to
'Xpos,Ypos=the coordinates of the text
'Text$=the string to print
'col= is the color to print(gradient)

x% = Xpos%
y% = Ypos%
Spacing% = 8
  FOR i% = 0 TO LEN(Text$) - 1
    x% = x% + Spacing%
    Offset% = 8 * ASC(MID$(Text$, i% + 1, 1)) + 14
    FOR j% = 0 TO 7
      DEF SEG = &HFFA6
      Bit% = PEEK(Offset% + j%)
      IF Bit% AND 1 THEN PSET (x%, y% + j%), col% + j%
      IF Bit% AND 2 THEN PSET (x% - 1, y% + j%), col% + j%
      IF Bit% AND 4 THEN PSET (x% - 2, y% + j%), col% + j%
      IF Bit% AND 8 THEN PSET (x% - 3, y% + j%), col% + j%
      IF Bit% AND 16 THEN PSET (x% - 4, y% + j%), col% + j%
      IF Bit% AND 32 THEN PSET (x% - 5, y% + j%), col% + j%
      IF Bit% AND 64 THEN PSET (x% - 6, y% + j%), col% + j%
      IF Bit% AND 128 THEN PSET (x% - 7, y% + j%), col% + j%
    NEXT j%
  NEXT i%

END SUB

SUB CalcNormals (Model() AS Point3d, ModelConnect() AS PolyType, v() AS vectorType, v2() AS vectorType)

FOR i = 0 TO UBOUND(v)

    p1 = ModelConnect(i).p1
    p2 = ModelConnect(i).p2
    p3 = ModelConnect(i).p3
    x1 = Model(p1).x
    x2 = Model(p2).x
    x3 = Model(p3).x
    y1 = Model(p1).y
    y2 = Model(p2).y
    y3 = Model(p3).y
    Z1 = Model(p1).z
    Z2 = Model(p2).z
    Z3 = Model(p3).z

    ax! = x2 - x1
    bx! = x3 - x2
    ay! = y2 - y1
    by! = y3 - y2
    az! = Z2 - Z1
    bz! = Z3 - Z2

    'Cross product
    xnormal! = ay! * bz! - az! * by!
    ynormal! = az! * bx! - ax! * bz!
    znormal! = ax! * by! - ay! * bx!

    'Normalize
    Mag! = SQR(xnormal! ^ 2 + ynormal! ^ 2 + znormal! ^ 2)
    IF Mag! <> 0 THEN
        xnormal! = xnormal! / Mag!
        ynormal! = ynormal! / Mag!
        znormal! = znormal! / Mag!
    END IF

        IF znormal! < -1 THEN
            znormal! = -1
        ELSEIF znormal! > 1 THEN
            znormal! = 1
        END IF

        IF xnormal! < -1 THEN
            xnormal! = -1
        ELSEIF xnormal! > 1 THEN
            xnormal! = 1
        END IF

        IF ynormal! < -1 THEN
            yxnormal! = -1
        ELSEIF ynormal! > 1 THEN
            ynormal! = 1
        END IF

    v(i).x = xnormal!
    v(i).y = ynormal!
    v(i).z = znormal!

NEXT i

'VertexNormal
'Algo: since we cannot find a normal to a point(doh?!!!) we find adjacent
        'planes(faces) of the polyhedra that a vertex is located then adding
        'all the facenormals of all the faces that a particular vertex is
        'located.
FOR i = 0 TO UBOUND(Model) - 1
    xnormal! = 0
    ynormal! = 0
    znormal! = 0
    FaceFound = 0
    FOR j = 0 TO UBOUND(ModelConnect)
        IF ModelConnect(j).p1 = i OR ModelConnect(j).p2 = i OR ModelConnect(j).p3 = i THEN
            xnormal! = xnormal! + v(j).x
            ynormal! = ynormal! + v(j).y
            znormal! = znormal! + v(j).z
            FaceFound = FaceFound + 1
        END IF
    NEXT j
    xnormal! = xnormal! / FaceFound
    ynormal! = ynormal! / FaceFound
    znormal! = znormal! / FaceFound
    v2(i).x = xnormal!
    v2(i).y = ynormal!
    v2(i).z = znormal!
NEXT i


END SUB

SUB CalcUV (Poly() AS PolyType, VertexNormal() AS vectorType)
'problem here. ;*)
Nface = UBOUND(Poly) - 1
FOR i = 0 TO Nface
    Poly(i).u1 = TorusModel(Poly(i).p1).x + 64
    Poly(i).v1 = TorusModel(Poly(i).p1).x + 64
    Poly(i).u2 = TorusModel(Poly(i).p2).x + 64
    Poly(i).v2 = TorusModel(Poly(i).p2).x + 64
    Poly(i).u3 = TorusModel(Poly(i).p3).x + 64
    Poly(i).v3 = TorusModel(Poly(i).p3).x + 64
NEXT i
END SUB

SUB DrawTorus (Model() AS Point3d, Poly() AS PolyType) STATIC
'Flat shade
FOR i = 0 TO UBOUND(Poly) - 1
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).ScrX       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).ScrX       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).ScrX       'Does not require a Z coord
    y1 = Model(Poly(j).p1).ScrY       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).ScrY       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).ScrY


    'Use the Znormal,the Ray perpendicular(Orthogonal) to the XY plane
    'Defined by the Triangle (X1,Y1,X2,Y2,X3,Y3)
    'if Greater(>) 0 then its facing in the opposite direction so
    'don't plot. If <0 then its facing towards you so Plot.
    znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF znormal < 0 THEN
            FlatTri x1, y1, x2, y2, x3, y3, Poly(j).clr
    END IF

NEXT i

END SUB

SUB DrawTorusG (Model() AS Point3d, Poly() AS PolyType) STATIC
'Gouraud shading
Nface = UBOUND(Poly) - 1
FOR i = 0 TO Nface
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).ScrX       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).ScrX       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).ScrX       'Does not require a Z coord
    y1 = Model(Poly(j).p1).ScrY       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).ScrY       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).ScrY

    znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF znormal < 0 THEN
        nx1! = TorusVertexNormal2(Poly(j).p1).x
        ny1! = TorusVertexNormal2(Poly(j).p1).y
        nz1! = TorusVertexNormal2(Poly(j).p1).z
        nx2! = TorusVertexNormal2(Poly(j).p2).x
        ny2! = TorusVertexNormal2(Poly(j).p2).y
        nz2! = TorusVertexNormal2(Poly(j).p2).z
        nx3! = TorusVertexNormal2(Poly(j).p3).x
        ny3! = TorusVertexNormal2(Poly(j).p3).y
        nz3! = TorusVertexNormal2(Poly(j).p3).z
        lx! = LightNormal.x
        ly! = LightNormal.y
        lz! = LightNormal.z
        Dot1! = (nx1! * lx!) + (ny1! * ly!) + (nz1! * lz!)
        IF Dot1! < 0 THEN
            Dot1! = 0
        ELSEIF Dot1! > 1 THEN
            Dot1! = 1
        END IF
        Dot2! = (nx2! * lx!) + (ny2! * ly!) + (nz2! * lz!)
        IF Dot2! < 0 THEN
            Dot2! = 0
        ELSEIF Dot2! > 1 THEN
            Dot2! = 1
        END IF
        Dot3! = (nx3! * lx!) + (ny3! * ly!) + (nz3! * lz!)
        IF Dot3! < 0 THEN
            Dot3! = 0
        ELSEIF Dot3! > 1 THEN
            Dot3! = 1
        END IF
            Clr1 = (Dot1! * 255)
            Clr2 = (Dot2! * 255)
            Clr3 = (Dot3! * 255)
            TriGouraud x1, y1, Clr1, x2, y2, Clr2, x3, y3, Clr3
    END IF

NEXT i


END SUB

SUB DrawTorusL (Model() AS Point3d, Poly() AS PolyType) STATIC
'Lambert shading
Nface = UBOUND(Poly) - 1
FOR i = 0 TO Nface
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).ScrX       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).ScrX       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).ScrX       'Does not require a Z coord
    y1 = Model(Poly(j).p1).ScrY       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).ScrY       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).ScrY


    znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF znormal < 0 THEN
        nx! = TorusNormal(j).x
        ny! = TorusNormal(j).y
        nz! = TorusNormal(j).z
        lx! = LightNormal.x
        ly! = LightNormal.y
        lz! = LightNormal.z
        Dot! = (nx! * lx!) + (ny! * ly!) + (nz! * lz!)
        IF Dot! < 0 THEN
            Dot! = 0
        ELSEIF Dot! > 1 THEN
            Dot! = 1
        END IF
            clr% = Dot! * 255
            'FlatTri x1, y1, x2, y2, x3, y3, 255 - j'clr%
            FlatTri x1, y1, x2, y2, x3, y3, clr%

    END IF
NEXT i

END SUB

SUB DrawTorusP (Model() AS Point3d, Poly() AS PolyType) STATIC
'textured

FOR i = 0 TO UBOUND(Poly) - 1
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).ScrX       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).ScrX       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).ScrX       'Does not require a Z coord
    y1 = Model(Poly(j).p1).ScrY       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).ScrY       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).ScrY

    znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF znormal < 0 THEN
        u1 = Poly(j).u1
        v1 = Poly(j).v1
        u2 = Poly(j).u2
        v2 = Poly(j).v2
        u3 = Poly(j).u3
        v3 = Poly(j).v3

        Tritexture VARSEG(Texture%(0)), x1, y1, u1, v1, x2, y2, u2, v2, x3, y3, u3, v3
    END IF
NEXT i

END SUB

SUB DrawTorusT (Model() AS Point3d, Poly() AS PolyType) STATIC
'textured

FOR i = 0 TO UBOUND(Poly) - 1
    j = Poly(i).idx
    x1 = Model(Poly(j).p1).ScrX       'Get triangles from "projected"
    x2 = Model(Poly(j).p2).ScrX       'X and Y coords since Znormal
    x3 = Model(Poly(j).p3).ScrX       'Does not require a Z coord
    y1 = Model(Poly(j).p1).ScrY       'V1= Point1 connected to V2 then
    y2 = Model(Poly(j).p2).ScrY       'V2 to V3 and so on...
    y3 = Model(Poly(j).p3).ScrY

    znormal = (x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)
    IF znormal < 0 THEN
        u1 = 63          'Sorry bout this
        v1 = 63          'hehehehehe
        u2 = 63
        v2 = 0
        u3 = 0
        v3 = 63

        IF Poly(j).Texture = 1 THEN
            Tritexture VARSEG(Texture%(0)), x1, y1, u1, v1, x2, y2, u2, v2, x3, y3, u3, v3
        ELSE
            Tritexture VARSEG(Texture2%(0)), x1, y1, u1, v1, x2, y2, u2, v2, x3, y3, u3, v3
        END IF
    END IF
NEXT i

END SUB

SUB FlatTri (xx1%, yy1%, xx2%, yy2%, xx3%, yy3%, col%)
'Generic's sub


y1% = yy1%          'Added this since swapping stuff made some
y2% = yy2%          'errors on my first version
y3% = yy3%          'Sorry Alan  ;*)
x1% = xx1%
x2% = xx2%
x3% = xx3%


IF y1% > y2% THEN SWAP y1%, y2%: SWAP x1%, x2%
IF y1% > y3% THEN SWAP y1%, y3%: SWAP x1%, x3%
IF y2% > y3% THEN SWAP y2%, y3%: SWAP x2%, x3%

' need to check for divide by zero..

ydiffa% = y2% - y1%
IF ydiffa% THEN d1& = ((x2% - x1%) * 65536) \ ydiffa%

ydiffb% = y3% - y2%
IF ydiffb% THEN d2& = ((x3% - x2%) * 65536) \ ydiffb%
                                       
ydiffc% = 1 + y3% - y1%
IF ydiffc% THEN d3& = ((x3% - x1%) * 65536) \ ydiffc%
                                       
lx& = x1% * 65536
rx& = x1% * 65536
                                       
FOR y% = y1% TO y2% - 1
  LINE (lx& \ 65536, y%)-(rx& \ 65536, y%), col%
  lx& = lx& + d1&
  rx& = rx& + d3&
NEXT

lx& = x2% * 65536

FOR y% = y2% TO y3%
  LINE (lx& \ 65536, y%)-(rx& \ 65536, y%), col%
  lx& = lx& + d2&
  rx& = rx& + d3&
NEXT y%

END SUB

SUB GreyScalePal

'Grey Scale the Palette
 FOR i = 0 TO 255
  OUT &H3C8, i
  OUT &H3C9, i \ 6
  OUT &H3C9, i \ 4
  OUT &H3C9, i \ 6
 NEXT i


END SUB

SUB HLine (x1%, x2%, y%, Col1&, Col2&)
'Generic's routine..
'Rels Note: I emulated the BYVAL parameter passing since I was getting errors
            'in the Gouraud and texture stuff

xx1% = x1%
xx2% = x2%
yy% = y%
Clr1& = Col1&
Clr2& = Col2&

IF xx1% > xx2% THEN SWAP xx1%, xx2%: SWAP Clr1&, Clr2&
xdiff% = 1 + xx2% - xx1%

dc& = (Clr2& - Clr1&) \ xdiff%
col& = Clr1&

FOR l% = xx1% TO xx2%
PSET (l%, yy%), col& \ 65536
col& = col& + dc&
NEXT l%

END SUB

SUB HTLine (xx1%, xx2%, yy%, uu1&, uu2&, vv1&, vv2&)
'Generic's
'Rels Note: I emulated the BYVAL parameter passing since I was getting errors
            'in the Gouraud and texture stuff

x1% = xx1%
x2% = xx2%
y% = yy%
u1& = uu1&
v1& = vv1&
u2& = uu2&
v2& = vv2&


IF x1% > x2% THEN SWAP x1%, x2%: SWAP u1&, u2&: SWAP v1&, v2&
xdiff% = 1 + x2% - x1%

du& = (u2& - u1&) \ xdiff%
dv& = (v2& - v1&) \ xdiff%

u& = u1&
v& = v1&

FOR l% = x1% TO x2%
u% = (u& \ 65536) AND 31
v% = (v& \ 65536) AND 31
col% = PEEK(u% + v% * 32)
PSET (l%, y%), col%
u& = u& + du&
v& = v& + dv&
NEXT l%

END SUB

SUB LoadTorus2 (Rings, Bands, RINGRADIUS, BandRadius, Model() AS Point3d, Poly() AS PolyType)

MaxPoint% = Rings * Bands
REDIM Model((MaxPoint%)) AS Point3d



  A1! = 2 * PI / Rings: A2! = 2 * PI / Bands
  i% = 0
 FOR S2% = 0 TO Bands - 1
  FOR S1% = 0 TO Rings - 1
    x1! = COS(S1% * A1!) * RINGRADIUS
    y1! = SIN(S1% * A1!) * RINGRADIUS
     Model(i%).x = x1! + COS(S1% * A1!) * COS(S2% * A2!) * BandRadius
     Model(i%).y = y1! + SIN(S1% * A1!) * COS(S2% * A2!) * BandRadius
     Model(i%).z = SIN(S2% * A2!) * BandRadius
    i% = i% + 1
  NEXT S1%
 NEXT S2%


  i% = 0
  MaxTri% = 0
  FOR S1% = Bands - 1 TO 0 STEP -1
   FOR S2% = Rings - 1 TO 0 STEP -1
    i% = i% + 1
    MaxTri% = MaxTri% + 1
    i% = i% + 1
    MaxTri% = MaxTri% + 1
   NEXT S2%
  NEXT S1%

  REDIM Poly(MaxTri%) AS PolyType

  Txtr% = 1
  i% = 0
  FOR S1% = Bands - 1 TO 0 STEP -1
   FOR S2% = Rings - 1 TO 0 STEP -1
    Poly(i%).p1 = S1% * Rings + S2%
    Poly(i%).p3 = S1% * Rings + (S2% + 1) MOD Rings
    Poly(i%).p2 = (S1% * Rings + S2% + Rings) MOD MaxPoint%
    Poly(i%).clr = 2 + INT(RND * 254)
    Poly(i%).Texture = Txtr%
    i% = i% + 1
    Poly(i%).p1 = S1% * Rings + (S2% + 1) MOD Rings
    Poly(i%).p3 = (S1% * Rings + (S2% + 1) MOD Rings + Rings) MOD MaxPoint%
    Poly(i%).p2 = (S1% * Rings + S2% + Rings) MOD MaxPoint%
    Poly(i%).clr = 2 + INT(RND * 254)
    Poly(i%).Texture = Txtr%
    i% = i% + 1
    Txtr% = NOT Txtr%
   NEXT S2%
  NEXT S1%

REDIM TorusNormal(0 TO UBOUND(Poly))  AS vectorType
REDIM TorusNormal2(0 TO UBOUND(Poly)) AS vectorType

REDIM TorusVertexNormal(0 TO UBOUND(Model))  AS vectorType
REDIM TorusVertexNormal2(0 TO UBOUND(Model)) AS vectorType


END SUB

SUB RotateAndProject (Model() AS Point3d, AngleX, AngleY, AngleZ) STATIC

'Precalculate the SIN and COS of each angle
CX! = LCOS(AngleX)
SX! = LSIN(AngleX)
CY! = LCOS(AngleY)
SY! = LSIN(AngleY)
CZ! = LCOS(AngleZ)
SZ! = LSIN(AngleZ)

'Transformation matrix formula
'This is actually 16(or 12) equations but I pared it down to 9
'since TX4=0,TY4=0,TZ4=0,13 to 16th =0,0,0,1 (yes Doom!!!)

TX1! = CY! * CZ!
TX2! = CY! * SZ!
TX3! = -SY!
TY1! = CX! * -SZ! + SX! * SY! * CZ!
TY2! = CX! * CZ! + SX! * SY! * SZ!
TY3! = SX! * CY!
TZ1! = -SX! * -SZ! + CX! * SY! * CZ!
TZ2! = -SX! * CZ! + CZ! * SY! * SZ!
TZ3! = CX! * CY!


FOR i = 0 TO UBOUND(Model) - 1

        x! = Model(i).x       'Load Original model
        y! = Model(i).y
        z! = Model(i).z

        RotX! = (x! * TX1! + y! * TY1! + z! * TZ1!)
        RotY! = (x! * TX2! + y! * TY2! + z! * TZ2!)
        RotZ! = (x! * TX3! + y! * TY3! + z! * TZ3!)

        Model(i).Xr = RotX!
        Model(i).Yr = RotY!
        Model(i).Zr = RotZ!


        'Project
        Distance% = (LENS - RotZ!)
        IF Distance% THEN
            Model(i).ScrX = (zcenter * RotX! / Distance%) + XCENTER + CamX
            Model(i).ScrY = -(zcenter * RotY! / Distance%) + YCENTER + CamY
        ELSE
        END IF
NEXT i

END SUB

SUB RotNormals (v() AS vectorType, v2() AS vectorType, AngleX, AngleY, AngleZ)

'Precalculate the SIN and COS of each angle
CX! = LCOS(AngleX)
SX! = LSIN(AngleX)
CY! = LCOS(AngleY)
SY! = LSIN(AngleY)
CZ! = LCOS(AngleZ)
SZ! = LSIN(AngleZ)

'Transformation matrix formula
'This is actually 16(or 12) equations but I pared it down to 9
'since TX4=0,TY4=0,TZ4=0,13 to 16th =0,0,0,1 (yes Doom!!!)

TX1! = CY! * CZ!
TX2! = CY! * SZ!
TX3! = -SY!
TY1! = CX! * -SZ! + SX! * SY! * CZ!
TY2! = CX! * CZ! + SX! * SY! * SZ!
TY3! = SX! * CY!
TZ1! = -SX! * -SZ! + CX! * SY! * CZ!
TZ2! = -SX! * CZ! + CZ! * SY! * SZ!
TZ3! = CX! * CY!


FOR i = 0 TO UBOUND(v)

        x! = v(i).x       'Load Original vector
        y! = v(i).y
        z! = v(i).z

        RotX! = (x! * TX1! + y! * TY1! + z! * TZ1!)
        RotY! = (x! * TX2! + y! * TY2! + z! * TZ2!)
        RotZ! = (x! * TX3! + y! * TY3! + z! * TZ3!)

        IF RotZ! < -1 THEN
            RotZ! = -1
        ELSEIF RotZ! > 1 THEN
            RotZ! = 1
        END IF

        IF RotX! < -1 THEN
            RotX! = -1
        ELSEIF RotX! > 1 THEN
            RotX! = 1
        END IF

        IF RotY! < -1 THEN
            RotY! = -1
        ELSEIF RotY! > 1 THEN
            RotY! = 1
        END IF


        v2(i).x = RotX!
        v2(i).y = RotY!
        v2(i).z = RotZ!
NEXT i

END SUB

SUB SetPlasmaPal

'Our nifty palette generator
'wraps the pal around so that the plama would
'look continous.
j! = 255 / 360 * 3          'Maxcolor/2PI*Frequency
k! = 255 / 360 * 1
l! = 255 / 360 * 1
FOR i% = 0 TO 255
    OUT &H3C8, i%
    m% = INT(a!)
    n% = INT(b!)
    o% = INT(C!)
    r% = 63 * ABS(SIN(m% * PI / 180))       'The sine-wwave
    g% = 63 * ABS(SIN(n% * PI / 180))
    b% = 63 * ABS(SIN(o% * PI / 180))
    a! = a! + j!
    b! = b! + k!
    C! = C! + l!
    OUT &H3C9, r%
    OUT &H3C9, g%
    OUT &H3C9, b%
NEXT


END SUB

SUB SetVideoSeg (Segment) STATIC
'By Plasma 357 (Jon Petrosky)

DEF SEG

IF VideoAddrOff& = 0 THEN ' First time the sub is called

' We need to find the location of b$AddrC, which holds the graphics
' offset (b$OffC) and segment (b$SegC). Since b$AddrC is in the default
' segment, we can find it by setting it to a certain value, and then
' searching for that value.

SCREEN 13 ' Set b$SegC to A000 (00A0 in memory)
PSET (160, 100), 0 ' Set b$OffC to 7DA0 (not needed in the IDE)

FOR Offset& = 0 TO 32764 ' Search for b$AddrC, which is
IF PEEK(Offset&) = &HA0 THEN ' in the default segment and
IF PEEK(Offset& + 1) = &H7D THEN ' should have a value of
IF PEEK(Offset& + 2) = &H0 THEN ' A0 7D 00 A0.
IF PEEK(Offset& + 3) = &HA0 THEN
VideoAddrOff& = Offset& + 2 ' If we found it, record the
EXIT FOR ' offset of b$SegC and quit
END IF ' looking. (Oddly, changing
END IF ' the b$OffC doesn't seem to
END IF ' do anything, so this is why
END IF ' this sub only changes b$SegC)
NEXT

END IF

' Change b$SegC to the specified Segment

POKE VideoAddrOff&, Segment AND &HFF
POKE VideoAddrOff& + 1, (Segment AND &HFF00&) \ &H100



END SUB

SUB SortIndex (Poly() AS PolyType, Min, Max)
    'Shell sort Algorithm
    ' Set comparison offset to half the number of records.
    Offset = Max \ 2

    ' Loop until offset gets to zero.
    DO WHILE Offset > 0

        Limit = Max - Offset

        DO

            ' Assume no switches at this offset.
            Switch = False

            ' Compare elements for the specified field and switch
            ' any that are out of order.
            FOR i = Min TO Limit - 1
                Ti = Poly(i).zcenter
                Tj = Poly(i + Offset).zcenter
                        IF Ti > Tj THEN
                            SWAP Poly(i).idx, Poly(i + Offset).idx
                            SWAP Poly(i).zcenter, Poly(i + Offset).zcenter
                            Switch = i
                        END IF

            NEXT i

            ' Sort on next pass only to location where last switch was made.
            Limit = Switch

        LOOP WHILE Switch

        ' No switches at last offset. Try an offset half as big.
        Offset = Offset \ 2
    LOOP



END SUB

SUB SortPolys (Model() AS Point3d, Poly() AS PolyType)

 FOR i% = 0 TO UBOUND(Poly)' - 1
  Poly(i%).zcenter = Model(Poly(i%).p1).Zr + Model(Poly(i%).p2).Zr + Model(Poly(i%).p3).Zr
  Poly(i%).idx = i%
 NEXT i%

 SortIndex Poly(), 0, UBOUND(Poly) '- 1

END SUB

SUB TriGouraud (xx1%, yy1%, Cc1%, xx2%, yy2%, Cc2%, xx3%, yy3%, Cc3%)
'Generic's routine..
'Rels Note: I emulated the BYVAL parameter passing since I was getting errors
            'in the Gouraud and texture stuff


y1% = yy1%          'Added this since swapping stuff made some
y2% = yy2%          'errors on my first version
y3% = yy3%          'Sorry Alan  ;*)
x1% = xx1%
x2% = xx2%
x3% = xx3%
C1% = Cc1%
C2% = Cc2%
C3% = Cc3%

IF y1% > y2% THEN SWAP y1%, y2%: SWAP x1%, x2%: SWAP C1%, C2%
IF y1% > y3% THEN SWAP y1%, y3%: SWAP x1%, x3%: SWAP C1%, C3%
IF y2% > y3% THEN SWAP y2%, y3%: SWAP x2%, x3%: SWAP C2%, C3%

'       (1)
'      /   \
'    (2)
'         \  (3)

' need to check for divide by zero - Not any more!
' call me mad! find more madness elsewhere for less and
' get double the difference refunded back, that's right
' double the difference ......... GUARANTEED!

ydiffa% = y2% - y1%
IF ydiffa% THEN
  d1& = ((x2% - x1%) * 65536) \ ydiffa%  ' NOTE:
  gd1& = ((C2% - C1%) * 65536) \ ydiffa%' LONG because need to represent
END IF                                 ' -255 AND 255... experimented with
                                       ' 16 bit rep. with a 7 fixed bit shift
                                       ' (128 of course) but the gradient
                                       ' looked a bit dodgy.
ydiffb% = y3% - y2%
IF ydiffb% THEN
  d2& = ((x3% - x2%) * 65536) \ ydiffb%
  gd2& = ((C3% - C2%) * 65536) \ ydiffb%
END IF

ydiffc% = y3% - y1%
IF ydiffc% THEN
  d3& = ((x3% - x1%) * 65536) \ ydiffc%
  gd3& = ((C3% - C1%) * 65536) \ ydiffc%
END IF

lx& = x1% * 65536
rx& = x1% * 65536

lc& = C1% * 65536
rc& = lc&

FOR y% = y1% TO y2% - 1
HLine (lx& \ 65536), (rx& \ 65536), y%, (lc&), (rc&)
  lx& = lx& + d1&
  rx& = rx& + d3&
  lc& = lc& + gd1&
  rc& = rc& + gd3&
NEXT
' HERE d1 has been added (y2%-y1%)+1 times to lx  = x2
'      d3 has been added (y2%-y1%)+1 times to rx

lx& = (x2% * 65536)     ' NOT NEEDED (for accuracy only)
lc& = C2% * 65536        ' NOT NEEDED (for accuracy only)

FOR y% = y2% TO y3%
  HLine (lx& \ 65536), (rx& \ 65536), y%, (lc&), (rc&)
  lx& = lx& + d2&
  rx& = rx& + d3&
  lc& = lc& + gd2&
  rc& = rc& + gd3&
NEXT y%

END SUB

SUB Tritexture (textseg%, xx1%, yy1%, uu1%, vv1%, xx2%, yy2%, uu2%, vv2%, xx3%, yy3%, uu3%, vv3%)
'Generic's
'Rels Note: I emulated the BYVAL parameter passing since I was getting errors
            'in the Gouraud and texture stuff

x1% = xx1%
y1% = yy1%
u1% = uu1%
v1% = vv1%

x2% = xx2%
y2% = yy2%
u2% = uu2%
v2% = vv2%

x3% = xx3%
y3% = yy3%
u3% = uu3%
v3% = vv3%




DEF SEG = textseg%
'LINE (x1%, y1%)-(x2%, y2%), 2    '  triangle outline
'LINE (x2%, y2%)-(x3%, y3%), 2    '
'LINE (x3%, y3%)-(x1%, y1%), 2    '

IF y1% > y2% THEN SWAP y1%, y2%: SWAP x1%, x2%: SWAP u1%, u2%: SWAP v1%, v2%
IF y1% > y3% THEN SWAP y1%, y3%: SWAP x1%, x3%: SWAP u1%, u3%: SWAP v1%, v3%
IF y2% > y3% THEN SWAP y2%, y3%: SWAP x2%, x3%: SWAP u2%, u3%: SWAP v2%, v3%

'       (1)
'      /   \
'    (2)
'         \  (3)

' need to check for divide by zero - Not any more!
' call me mad! find more madness elsewhere for less and
' get double the difference refunded back, that's right
' double the difference ......... GUARANTEED!

d1& = 0: dg1 = 0

ydiffa% = y2% - y1%
IF ydiffa% THEN
d1& = ((x2% - x1%) * 65536) \ ydiffa%
ud1& = ((u2% - u1%) * 65536) \ ydiffa%
vd1& = ((v2% - v1%) * 65536) \ ydiffa%
END IF

ydiffb% = y3% - y2%
IF ydiffb% THEN
d2& = ((x3% - x2%) * 65536) \ ydiffb%
ud2& = ((u3% - u2%) * 65536) \ ydiffb%
vd2& = ((v3% - v2%) * 65536) \ ydiffb%
END IF

ydiffc% = y3% - y1%
IF ydiffc% THEN
d3& = ((x3% - x1%) * 65536) \ ydiffc%
ud3& = ((u3% - u1%) * 65536) \ ydiffc%
vd3& = ((v3% - v1%) * 65536) \ ydiffc%
END IF

lx& = x1% * 65536
rx& = x1% * 65536

lu& = u1% * 65536: ru& = lu&
lv& = v1% * 65536: rv& = lv&

FOR y% = y1% TO y2% - 1
HTLine (lx& \ 65536), (rx& \ 65536), y%, (lu&), (ru&), (lv&), (rv&)
  lx& = lx& + d1&
  rx& = rx& + d3&
  lu& = lu& + ud1&
  ru& = ru& + ud3&
  lv& = lv& + vd1&
  rv& = rv& + vd3&
NEXT

lx& = (x2% * 65536)
lu& = u2% * 65536
lv& = v2% * 65536

' HERE d1 has been added (y2%-y1%)+1 times to lx  = x2
'      d3 has been added (y2%-y1%)+1 times to rx

FOR y% = y2% TO y3%

  HTLine (lx& \ 65536), (rx& \ 65536), y%, (lu&), (ru&), (lv&), (rv&)

  lx& = lx& + d2&
  rx& = rx& + d3&
  lu& = lu& + ud2&
  ru& = ru& + ud3&
  lv& = lv& + vd2&
  rv& = rv& + vd3&
NEXT y%


END SUB

